"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var mongodb = require("mongodb");
var common_1 = require("../common");
var interface_1 = require("./interface");
var helper_1 = require("../helper");
var MongodbBackend = /** @class */ (function (_super) {
    __extends(MongodbBackend, _super);
    function MongodbBackend(options) {
        if (options === void 0) { options = {}; }
        var _this = _super.call(this) || this;
        _this.options = _.extend({
            url: 'mongodb://localhost:27017',
            dbName: 'blackfyre',
            collectionName: 'tasks',
            mongoClientOptions: null,
            resultsExpireIn: 3600 * 24,
        }, options);
        return _this;
    }
    MongodbBackend.prototype.getCollection = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, coll;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!!this.client) return [3 /*break*/, 2];
                        _a = this;
                        return [4 /*yield*/, mongodb.MongoClient.connect(this.options.url, this.options.mongoClientOptions)];
                    case 1:
                        _a.client = _b.sent();
                        helper_1.registerEvent(['error', 'close'], this.client, this);
                        _b.label = 2;
                    case 2:
                        coll = this.client.db(this.options.dbName).collection(this.options.collectionName);
                        return [4 /*yield*/, coll.createIndex({
                                state: 1,
                            }, {
                                background: true,
                                expireAfterSeconds: this.options.resultsExpireIn,
                            })];
                    case 3:
                        _b.sent();
                        return [2 /*return*/, coll];
                }
            });
        });
    };
    MongodbBackend.prototype.updateState = function (task) {
        return __awaiter(this, void 0, void 0, function () {
            var coll;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getCollection()];
                    case 1:
                        coll = _a.sent();
                        task.created = task.created || new Date();
                        task.updated = new Date();
                        return [4 /*yield*/, coll.updateOne({
                                _id: task.id,
                            }, {
                                $set: task,
                            }, {
                                upsert: true,
                            })];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    MongodbBackend.prototype.setTaskStatePending = function (task) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                task.state = common_1.TaskState.PENDING;
                return [2 /*return*/, this.updateState(task)];
            });
        });
    };
    MongodbBackend.prototype.setTaskStateReceived = function (task) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                task.state = common_1.TaskState.RECEIVED;
                return [2 /*return*/, this.updateState(task)];
            });
        });
    };
    MongodbBackend.prototype.setTaskStateStarted = function (task) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                task.state = common_1.TaskState.STARTED;
                return [2 /*return*/, this.updateState(task)];
            });
        });
    };
    MongodbBackend.prototype.setTaskStateRetrying = function (task, err) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                task.state = common_1.TaskState.RETRYING;
                task.error = err.toString();
                task.errorStack = err.stack.split('\n');
                return [2 /*return*/, this.updateState(task)];
            });
        });
    };
    MongodbBackend.prototype.setTaskStateSucceed = function (task, result) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                task.state = common_1.TaskState.SUCCEED;
                task.result = result;
                return [2 /*return*/, this.updateState(task)];
            });
        });
    };
    MongodbBackend.prototype.setTaskStateFailed = function (task, err) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                task.state = common_1.TaskState.FAILED;
                task.error = err.toString();
                task.errorStack = err.stack.split('\n');
                return [2 /*return*/, this.updateState(task)];
            });
        });
    };
    MongodbBackend.prototype.getTask = function (taskID) {
        return __awaiter(this, void 0, void 0, function () {
            var coll;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getCollection()];
                    case 1:
                        coll = _a.sent();
                        return [2 /*return*/, coll.findOne({
                                _id: taskID,
                            })];
                }
            });
        });
    };
    MongodbBackend.prototype.removeTask = function (taskID) {
        return __awaiter(this, void 0, void 0, function () {
            var coll;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getCollection()];
                    case 1:
                        coll = _a.sent();
                        return [4 /*yield*/, coll.remove({
                                _id: taskID,
                            })];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    MongodbBackend.prototype.checkHealth = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (!this.client)
                    return [2 /*return*/, {}];
                return [2 /*return*/, this.client.db(this.options.dbName).admin().ping()];
            });
        });
    };
    MongodbBackend.prototype.close = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (this.client) {
                    this.client.close();
                }
                return [2 /*return*/];
            });
        });
    };
    return MongodbBackend;
}(interface_1.Backend));
exports.MongodbBackend = MongodbBackend;
//# sourceMappingURL=mongodb.js.map